/****************************************************************************
 *   FILE OLDCKIT.H                                                         *
 *   Created 16-Aug-1991            Rickie W. Belitz                        *
 *                                  820 Brentwood Drive                     *
 *                                  Maryville, Tennessee  37801             *
 *                                  BBS (615) 982-6512                      *
 *                                      (615) 982-6537                      *
 *                                      (615) 982-8723                      *
 *                                                                          *
 *    Allows compatiblity with older CKIT door source codes.                *
 *                                                                          *
 ****************************************************************************/

/***********************************************************************
 *  Include this in your source code to allow the compiler to use      *
 *  the CKIT old names, if desired.  This will prevent you from        *
 *  having to change the older names to the new names.  You can        *
 *  also change CKIT's variable/function names to anything desired.    *
 *                                                                     *
 *  #include    "oldckit.h"                                            *
 *  #include    "ckit.h"                                               *
 ***********************************************************************/

/***********************************************************************
 *   CKIT macros for 2.0 downward compatibilty.                        *
 *                                                                     *
 *  #define   name_desired     new_name                                *
 *                                                                     *
 ***********************************************************************/
#define r_count                     ck_r_count
#define tqueue_len                  ck_tqueue_len
#define flush_RQUEUE                ck_flush_RQUEUE
#define mins_left_system            ck_mins_left_system
#define lower_dtr                   ck_lower_dtr
#define raise_dtr                   ck_raise_dtr
#define check_cd                    ck_check_cd
#define transmit_modem              ck_transmit_modem
#define clear_screen                ck_clear_screen
#define ck_wait                     ck_wait
#define event_minutes               ck_event_minutes
#define s_putc                      ck_s_putc
#define adjust_time_allowed         ck_adjust_time_allowed
#define get_time                    ck_get_time
#define close_door                  ck_close_door
#define open_door                   ck_open_door
#define force_offhook               ck_force_offhook
#define force_enter                 ck_force_enter
#define input                       ck_input
#define get_nextpar                 ck_get_nextpar
#define get_cmdline_raw             ck_get_cmdline_raw
#define get_cmdline                 ck_get_cmdline
#define sio_getbyte                 ck_sio_getbyte
#define getkey                      ck_getkey
#define inkey                       ck_inkey
#define nomore                      ck_nomore
#define get_defyn                   ck_get_defyn
#define get_defen                   ck_get_defen
#define get_defn                    ck_get_defn
#define get_def                     ck_get_def
#define prompt_def                  ck_prompt_def
#define display_file                ck_display_file
#define clear_eol                   ck_clear_eol
#define keystat                     ck_keystat
#define back_space                  ck_back_space
#define clr_screen                  ck_clr_screen
#define pos_cursor                  ck_pos_cursor
#define set_r_c                     ck_set_r_c
#define color                       ck_color
#define clear_row                   ck_clear_row
#define newline                     ck_newline
#define transmit_data               ck_transmit_data
#define s_putsn                     ck_s_putsn
#define debug_on                    ck_debug_on
#define debug_off                   ck_debug_off
#define update_user                 ck_update_user
#define carrier_on                  ck_carrier_on
#define carrier_off                 ck_carrier_off
#define s_putc                      ck_s_putc
#define s_putstd                    ck_s_putstd
#define s_puts                      ck_s_puts
#define s_putv                      ck_s_putv
#define check_time_left             ck_check_time_left
#define purge_buffer                ck_purge_buffer
#define check_CR                    ck_check_CR
#define check_keypress              ck_check_keypress
#define dos_shell                   ck_dos_shell
#define wait_keypress               ck_wait_keypress
#define check_event                 ck_check_event
#define mins_before_event           ck_mins_before_event
#define CtrlK_ON                    ck_CtrlK_ON
#define CtrlK_OFF                   ck_CtrlK_OFF
#define check_CTRL_K                ck_check_CTRL_K
#define set_kybd_time               ck_set_kybd_time
#define par                         ck_par
#define cmdline                     ck_cmdline
#define system_time_HHMMSS          ck_system_time_HHMMSS
#define todays_date_MMDDYY          ck_todays_date_MMDDYY
#define firstname                   ck_firstname
#define fullname                    ck_fullname
#define bps_open                    ck_bps_open
#define baud_rate                   ck_baud_rate
#define sysop_next                  ck_sysop_next
#define netchat                     ck_netchat
#define password                    ck_password
#define time_logged                 ck_time_logged
#define language                    ck_language
#define event_time                  ck_event_time
#define aport                       ck_aport
#define upload_total                ck_upload_total
#define dload_total                 ck_dload_total
#define daily_bytes                 ck_daily_bytes
#define node                        ck_node
#define PCB                         ck_PCB
#define parity                      ck_parity
#define expert                      ck_expert
#define min_remaining               ck_min_remaining
#define sec_remaining               ck_sec_remaining
#define parity                      ck_parity
#define expert                      ck_expert
#define PCB12                       ck_PCB12
#define page_length                 ck_page_length
#define caller_bday                 ck_caller_bday
#define main_dir                    ck_main_dir
#define gen_dir                     ck_gen_dir
#define sysop_name                  ck_sysop_name
#define sysop_alias                 ck_sysop_alias
#define ansi_ng                     ck_ansi_ng
#define record_lock                 ck_record_lock
#define default_color               ck_default_color
#define last_file_scan              ck_last_file_scan
#define daily_files                 ck_daily_files
#define max_files                   ck_max_files
#define total_doors                 ck_total_doors
#define msgs_left                   ck_msgs_left
#define last_called                 ck_last_called
#define daily_files                 ck_daily_files
#define download_Kbytes             ck_download_Kbytes
#define upload_Kbytes               ck_upload_Kbytes
#define key_source                  ck_key_source
#define mem_msg                     ck_mem_msg
#define GAP                         ck_GAP
#define GENERIC                     ck_GENERIC
#define pcbsysbuf                   ck_pcbsysbuf
#define RBBS                        ck_RBBS
#define user_record                 ck_user_record
#define option                      ck_option
#define port                        ck_port
#define error_connection            ck_error_connection
#define BBSname                     ck_BBSname
#define time_on                     ck_time_on
#define prev_used                   ck_prev_used
#define time_limit                  ck_time_limit
#define dload_limit                 ck_dload_limit
#define time_added                  ck_time_added
#define user                        ck_user
#define time_credit                 ck_time_credit
#define min_left                    ck_min_left
#define event_active                ck_event_active
#define event_slide                 ck_event_slide
#define current_conf                ck_current_conf
#define conferences                 ck_conferences
#define linenum                     ck_linenum
#define time_credit_old             ck_time_credit_old
#define graphics                    ck_graphics
#define display                     ck_display
#define printer                     ck_printer
#define pagebell                    ck_pagebell
#define callalarm                   ck_callalarm
#define local                       ck_local
#define DUMP_USER                   ck_DUMP_USER
#define DOTS                        ck_DOTS
#define FORCEOFFHOOK                ck_FORCEOFFHOOK
#define USERSFILE                   ck_USERSFILE
#define protocol                    ck_protocol
#define high_msg                    ck_high_msg
#define monitor_type                ck_monitor_type
#define max_sec                     ck_max_sec
#define name_in_use                 ck_name_in_use
#define door_opened                 ck_door_opened
#define WILDCAT                     ck_WILDCAT
#define security_level              ck_security_level
#define scan_code                   ck_scan_code
#define logoff_color                ck_logoff_color
#define error_msg11                 ck_error_msg11
#define chatmode                    ck_chatmode
#define uart_base                   ck_uart_base
#define irq                         ck_irq
#define non_ibm                     ck_non_ibm
#define ck_logoff_msgs              ck_logoff_msgs
#define etadpu_posys                ck_etadpu_posys
#define ck_gen_msgs                 ck_gen_msgs
#define system_time_used            ck_system_time_used
#define set_ANSI                    ck_set_ANSI
#define FOSSIL                      ck_FOSSIL
#define silent                      ck_silent
#define NO_FKEYS                    ck_NO_FKEYS
#define NOSYSTEM                    ck_NOSYSTEM
#define Digiboard                   ck_Digiboard
/****************************************************************************
 ************************ E N D  OF  M O D U L E ****************************/
