///////////////////////////////////////////////////////////////////////////
//                                                                       //
//            File: XOnOff.h                                             //
//            started on: 23/2/92                                        //
//                                                                       //
///////////////////////////////////////////////////////////////////////////
//                                                                       //
//  This class submits to XON and XOFF requests and so is compatible     //
//  with some modems. Useful for software flow control, also...          //
//                                                                       //
///////////////////////////////////////////////////////////////////////////
//                                                                       //
//                    by Ofer Laor (AKA LeucroTTA)                       //
//                                                                       //
///////////////////////////////////////////////////////////////////////////

#ifndef __XONOFF_H
#define __XONOFF_H

#include "serial.h"; // SERIAL_PORT

const XON=  0x11;
const XOFF= 0x13;

class XONOFF : public SERIAL_PORT {

protected:
          virtual inline void flow_check(void);
          virtual inline BOOLEAN flow_set(BYTE in_byte);
public:

       XONOFF();
};

#endif /* __XONOFF_H */
